import gtk
import gtk.glade
import gnome.ui
import gnome
import gobject

import DNS

from Options import *

import RRGUI


class EditDialog:
    def selected(s,tree):
        selection = tree.get_selection()
        if( selection != None ):
            model, selected = selection.get_selected()
            if (model != None) and  (selected != None):
                return  model.get(selected, 0, 1, 2)
        return None
    
    def current_option_selected(s,opt):
        key,name,o=opt
        debug( "NEW OPTION SELECTION: ", key, 'OLD', s.currentOptionKey, s.currentOptionValue)
        if (s.currentOptionWidget != None):
            debug( 'OLD OPTION VALUE:',s.currentOptionWidget.value())
        if( s.currentOptionWidget != None ) and (s.currentOptionWidget.value() != s.currentOptionValue):
            debug( 'SAVING CURRENT OPTION WIDGET:', s.currentOptionKey, s.currentOptionWidget,  s.currentOptionValue)
            s.currentOptionWidget.save()
            error = s.options.change(s.currentOptionKey)
            if error != None:
                s.bind.gui.modalError(s.editDialog,_("Option Value Error"),error[1])
                s.optionWidget.grab_focus()
                return
        s.optionLabel.set_markup( '<b>' + key + ' ('+ name +')' + '</b>')
        s.optionInfoLabel.set_markup( '<b>' + key + ' ('+ name +')' + '</b>')
        s.optionInfo.set_markup(o.option['desc'])
        s.optionInfoWindow.resize_children()
#        print 'REMOVE : optionWidget:', s.optionWidget
        s.optionWidget.hide()
        for c in s.optionContainer.get_children():
            s.optionContainer.remove(c)        
        s.currentOptionKey = key
        if o.option.has_key('read-only'):                        
            s.currentOptionWidget=RRGUI.null_widget(s, o, o.value, key)
        else:
            s.currentOptionWidget=RRGUI.widget(RRGUI,o.value)(s, o, o.value, key)
        s.optionWidget = s.currentOptionWidget.widget()
        debug( 'NEW OPTION WIDGET: ',s.currentOptionWidget,s.optionWidget)
        s.currentOptionValue = s.currentOptionWidget.value()
        debug( 'NEW CURRENT OPTION WIDGET:', s.currentOptionKey, 'VALUE:', s.currentOptionValue)
        s.optionContainer.pack_start(s.optionWidget)
#        print 'ADD : optionWidget',s.optionWidget
        s.optionWidget.show()
    
    def all_option_selected(s,opt):
        debug( "ALL OPTION SELECTION: ", opt)
        key,name,o=opt
        s.optionInfoLabel.set_markup( '<b>' + key + ' ('+ name +')' + '</b>')
        s.optionInfo.set_markup(o['desc'])       
        s.optionInfoWindow.resize_children()
        
    def current_options_row_activated(s, tree, path, column):
        debug( 'CURRENT OPTIONS ROW ACTIVATED')
        s.current_option_selected(s.selected(tree))

    def current_options_row_selected(s,tree,e):
        debug( 'CURRENT OPTIONS ROW SELECTED')
        s.current_option_selected(s.selected(tree))

    def all_options_row_activated(s, tree, path, column):
        debug( 'ALL OPTIONS ROW ACTIVATED')
        s.all_option_selected(s.selected(tree))

    def all_options_row_selected(s,tree,e):
        debug( 'ALL OPTIONS ROW SELECTED'        )
        s.all_option_selected(s.selected(tree))

    def remove_option(s,b):
        key,name,option = s.selected(s.optionsTree)
        if option != None:
            debug( 'REMOVING option:',key,name,option)
            r = s.options.remove(key)
            if r != None:
                s.bind.gui.modalError(s.editDialog,None,
                                      _('The %s %s option cannot be removed from this %s: %s.') 
                                      %(s.options.type, key, s.options.type , r[1]),
                                      fatal=False)
                return False
        s.load()
        return False

    def add_option(s,b):
        key,name,option = s.selected(s.allOptionsTree)
        debug( 'Add option:', key, name, option)
        if option != None:
            r = s.options.add(key)
            if r != None:
                s.bind.gui.modalError(s.editDialog,None,
                                      _('The %s %s option cannot be added to this %s: %s.') 
                                      %(s.options.type, key, s.options.type , r[1]),
                                      fatal=False)
                return False
        debug( 'ADD OPTION: LOAD WITH KEY', key)
        if key == 'allow-update':
            s.madeUpdateable = True
        s.load(key)
        return False

    def end(s):
        debug( 'END EditDialog: ',s)
        s.optionWidget.hide()
        for c in s.optionContainer.get_children():
            s.optionContainer.remove(c)
        s.optionWidget=gtk.Label("")
        s.optionContainer.pack_start(s.optionWidget)
        for o,h in s.handlers:
            o.disconnect(h)
        s.handlers=[]
        s.optsList.clear()
        s.allOptsList.clear()
        s.editDialog.hide()        

    def answer(s,ans,arg=None):
        s.response(s.editDialog,gtk.RESPONSE_OK,answer=ans)

    def response(s,d,r,answer=None):
        debug( 'RESPONSE', type(r), r)
        if int(r) in [ int(gtk.RESPONSE_OK), int(gtk.RESPONSE_ACCEPT), int(gtk.RESPONSE_APPLY)]:
            if( s.currentOptionWidget != None ) and (s.currentOptionWidget.value() != s.currentOptionValue):
                debug( 'SAVING CURRENT OPTION:', s.currentOptionKey, s.currentOptionWidget, s.currentOptionValue)
                s.currentOptionWidget.save()
                error = s.options.change(s.currentOptionKey)
                if error != None:
                    s.bind.gui.modalError(s.editDialog,_("Option Value Error"),error[1])
                    s.optionWidget.grab_focus()
                    return True
            debug( 'EditDialog: UPDATE OPTIONS', s.options.key, 'RO:',s.read_only)
            if not s.read_only:
                if s.madeUpdateable:
                    if s.options.type == 'zone':
                        filename = s.options.zone.filename
                        dir = s.bind.nmdc.directory()
                        if (len(filename) > len(dir)) and (filename [ : len(dir) + 1 ] == dir + '/' ):
                            filename=filename[len(dir)+1:]                        
                            if ( filename[:7] != 'slaves/'):
                                if answer == None:                                
                                    ans = s.bind.gui.question(d, _("Warning:"), _("You have enabled DDNS updates to zone %s,\nbut the zone file %s is in directory %s,\nin which named is not allowed to update zone files.\nShall I move the zone file to slaves/ ?") % (s.options.zone.zone_origin, filename, dir))
                                    ans.question(s.answer)
                                    return False
                                elif answer == gtk.RESPONSE_OK:
                                    s.bind.moveZoneFile(s.options.zone, 'slaves/'+filename);
                s.options.update()
            else:
                s.bind.gui.warning(s.bind.gui.gui,_('Cannot Modify'),_('This zone cannot be modified on this server.'))
            if r != gtk.RESPONSE_APPLY:
                s.end()
        else:
            debug( 'RESPONSE: END')
            s.end()
        return True

    def on_delete(s, w, e):
        debug( 'ON DELETE: END')
        s.end()
        return True
    
    def __init__(s,bind,obj,read_only=False):
        debug( 'EDITDIALOG: me:',s)
        s.bind=bind
        s.gui = bind.gui
        s.obj = obj
        s.handlers=[]
        s.read_only = read_only
        s.editDialog = s.gui.xml.get_widget('OptionsDialog')
        s.handlers.append([s.editDialog,s.editDialog.connect('response',s.response)])
#        s.handlers.append([s.editDialog,s.editDialog.connect('delete_event',s.on_delete)])
        s.editDialog.connect('delete_event',s.on_delete)
        s.optionsTree = s.gui.xml.get_widget('CurrentOptionsList')
        for col in s.optionsTree.get_columns():
            s.optionsTree.remove_column(col)
        s.optionsTree.set_headers_visible(False)
        s.optsList = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
        s.olCell = gtk.CellRendererText()
        s.ol2Cell = gtk.CellRendererText()
        s.olColumn=gtk.TreeViewColumn(None,s.olCell,markup=0)
        s.ol2Column=gtk.TreeViewColumn(None,s.ol2Cell,markup=1)
        s.optionsTree.append_column(s.olColumn)
        s.optionsTree.append_column(s.ol2Column)
        s.optionsTree.set_model(s.optsList)        
        s.handlers.append([s.optionsTree,s.optionsTree.connect('row_activated',s.current_options_row_activated)])
        s.handlers.append([s.optionsTree,s.optionsTree.connect('button_release_event',s.current_options_row_selected)])
        s.allOptionsTree = s.gui.xml.get_widget('AllOptionsList')
        for col in s.allOptionsTree.get_columns():
            s.allOptionsTree.remove_column(col)
        s.allOptionsTree.set_headers_visible(False)
        s.allOptsList = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
        s.aolCell = gtk.CellRendererText()
        s.aol2Cell = gtk.CellRendererText()
        s.aolColumn=gtk.TreeViewColumn(None,s.aolCell,markup=0)
        s.aol2Column=gtk.TreeViewColumn(None,s.aol2Cell,markup=1)
        s.allOptionsTree.append_column(s.aolColumn)
        s.allOptionsTree.append_column(s.aol2Column)
        s.allOptionsTree.set_model(s.allOptsList)
        s.handlers.append([s.allOptionsTree,s.allOptionsTree.connect('row_activated',s.all_options_row_activated)])
        s.handlers.append([s.allOptionsTree,s.allOptionsTree.connect('button_release_event',s.all_options_row_selected)])
        s.name = None
        if ( type(obj) != type(None) ):
            if hasattr(obj,'key'):
                if hasattr(obj,'parent'):
                    s.name = obj.parent + [ obj.key ]
                else:
                    s.name = obj.key
            elif hasattr(obj,'nmdcKey'):
                s.name = obj.nmdcKey
        s.options = Options(bind.nmdc, s.name, obj)
        title=''
        if( s.name == None):
            title = _('DNS Server')
        else:
            if s.options.type == 'zone':
                title = _(s.options.type)+' '+obj['zone'].zone_origin
            elif s.options.type == 'view':
                title = _('View') + ' ' + s.name.strip('"')
            elif s.options.type == 'server':
                title = _('Server') + ' ' + s.name[-1]
        s.editDialog.set_title(title+' '+_('Options'))
        ol=s.bind.gui.xml.get_widget('CurrentOptionsLabel')
        ol.set_text(_('Current Options'))
        ol=s.bind.gui.xml.get_widget('AllOptionsLabel')
        ol.set_text(_('All Options'))
        s.optionLabel = s.bind.gui.xml.get_widget('OptionLabel')
        s.optionInfo =  s.bind.gui.xml.get_widget('OptionInfo')
        s.optionInfoLabel=s.bind.gui.xml.get_widget('OptionInfoLabel')
        s.optionInfoWindow = s.bind.gui.xml.get_widget('OptionInfoWindow')
        s.optionInfo.set_line_wrap(True)
        s.optionContainer= s.bind.gui.xml.get_widget('OptionFrameHBox')
        for c in s.optionContainer.get_children():
            s.optionContainer.remove(c)
        s.optionWidget=gtk.Label("")
        s.currentOptionWidget = None
        s.currentOptionValue=None
        s.currentOptionKey=None
        s.optionContainer.pack_start(s.optionWidget,False)
        s.removeOptionButton = s.bind.gui.xml.get_widget('RemoveOptionButton')
        s.addOptionButton = s.bind.gui.xml.get_widget('AddOptionButton')
        s.handlers.append([s.removeOptionButton,s.removeOptionButton.connect('clicked', s.remove_option)])
        s.handlers.append([s.addOptionButton,s.addOptionButton.connect('clicked', s.add_option)])
        s.load()
#        s.editDialog.resize_children()
        s.madeUpdateable = False
        s.editDialog.show_all()
    
    def load(s, selectedOption = None):
        s.optionsTree.hide()
        s.optsList.clear()
        firstNode = None
        path=0
        for optName in s.options.keys():
            opt = s.options[optName]
            debug( 'OPTION:',optName, opt.option['name'])
            s.optsList.append([optName, opt.option['name'],opt])
            if firstNode == None:
                if(selectedOption == None) or (selectedOption == optName):
                    debug( 'LOAD WITH selectedOption:',optName, path)
                    firstNode = (path,)
            path += 1
        s.optionsTree.show()
        s.allOptionsTree.hide()
        s.allOptsList.clear()        
        for key, opt in s.options.all_options():
            s.allOptsList.append([ key, opt['name'],opt ])
        s.allOptionsTree.show()
        if( firstNode != None ):
            s.optionsTree.set_cursor(firstNode)
            s.optionsTree.grab_focus()
            s.current_options_row_activated(s.optionsTree,firstNode,0)
        
